/* bkerndev - Bran's Kernel Development Tutorial
*  By:   Brandon F. (friesenb@gmail.com)
*  Desc: Global function declarations and type definitions
*
*  Notes: No warranty expressed or implied. Use at own risk. */
#ifndef __SYSTEM_H
#define __SYSTEM_H

typedef int size_t;

/* This defines what the stack looks like after an ISR was running */
struct regs
{
    unsigned int gs, fs, es, ds;
    unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax;
    unsigned int int_no, err_code;
    unsigned int eip, cs, eflags, useresp, ss;    
};

/* Sting.cpp */
#include <libc/string.h>
/* CONSOLE.C */
#include <sys/scrn.h>

/* GDT.C */
#include <sys/gdt.h>

/* IDT.C */
#include <sys/idt.h>

/* ISRS.C */
#include <sys/isrs.h>

/* IRQ.C */
#include <sys/irq.h>

/* TIMER.C */
#include <drivers/internal/timer.h>

/* KEYBOARD.C */
#include <drivers/external/kbc.h>

#endif
