#ifndef LIST_H
#define LIST_H

#include <x32.h>

typedef struct tagListElement {
	
	struct tagListElement * prev;
	struct tagListElement * next;
	
	uint32_t	   * item;

} __attribute__ ((packed)) ListElement;

typedef struct tagList {
	ListElement * first;
	ListElement * last;
	
	uint32_t		 size;

} __attribute__ ((packed)) List;

List *			NewList			();
void			ListAdd			(List *, void *);
void 			ListRemove		(List *, void *);
ListElement * 	ListFind		(List *, void *);
void *			ListGet			(List *, uint32_t);
void			DeleteList		(List *);
void			ListMoveToFirst	(List *, void *);
void			ListMoveToLast	(List *, void *);

#endif
