#ifndef MULTITASKING_H
#define MULTITASKING_H

#include <x32.h>

//PRIORITYS
#define HYPER_PRIORITY		6
#define SUPER_HIGH_PRIORITY	5
#define HIGH_PRIORITY		4
#define NORMAL_PRIORITY		3
#define LOW_PRIORITY		2
#define SUPER_LOW_PRIORITY	1

//TASK STATES
#define TASK_READY			0
#define TASK_RUNNING		1
#define TASK_WAITING		2
#define TASK_SLEEPING		3

#define KERNEL_TASK			0
#define USER_TASK			1

/*-------------TASK STRUCTURE------------*/
typedef struct {
    uint32_t 	ID;
    uint32_t 	Esp;
    uint32_t	Ss;
        
    uint32_t 	Parent;
    uint32_t 	Owner;
    uint32_t 	Group;
    uint32_t 	Timetorun;
    uint8_t 	State;
    uint8_t 	Priority;
    uint8_t		Type;
    uint32_t    box;
   
    uint8_t 	Name[32];
} __attribute__ ((packed)) TASK;



uint32_t	Scheduler		(uint32_t);
uint8_t 	SetupScheduler	();
uint32_t 	TaskAdd			(void *, uint8_t *, uint8_t, uint8_t);
uint8_t 	TaskRemove		(uint32_t);
uint8_t 	TaskSetPriority	(uint32_t, uint8_t);
uint8_t 	TaskSetState	(uint32_t, uint8_t);
TASK * 		TaskGetById		(uint32_t);
TASK * 		TaskGetCurrent	();

uint8_t		SetupKernelTask ();

//IDLE
void		IdleTask 		();

#endif
