/*
;
;---------------------------------------------------------------+
;       .__               __                          			
;______ |__|___________ _/  |_            ____  ______			
;\____ \|  \_  __ \__  \\   __\  ______  /  _ \/  ___/			
;|  |_> >  ||  | \// __ \|  |   /_____/ (  <_> )___ \ 			
;|   __/|__||__|  (____  /__|            \____/____  >			
;|__|                  \/                          \/ 			
;---------------------------------------------------------------+
;
;[1] Informations
;
; Last Modified: 	30. Dezember 2004
; Begin: 			15. Juni 2004
; Version: 			1.000
; Coder: 			z4ck
;
;
;[2] Tasks
;
;	Task									Done		Coder
;----------------------------------------------------------------
; - inb / outb Functions					[100%]		z4ck
;----------------------------------------------------------------
; TOTAL										[  0%]		z4ck
;================================================================
*/

#include <x32.h>

uint8_t inb(uint16_t _port)
{
	uint8_t result;
	asm volatile ("inb  %%dx, %%al" : "=a" (result) : "d" (_port) );
	return result;
};


void outb(uint16_t _port, uint8_t _value)
{
	asm volatile ("outb %%al, %%dx" : : "d" (_port), "a" (_value));
};

uint32_t ReadCr(uint8_t _cr)
{
	uint32_t result = 0;
	switch (_cr)
	{
		case 0:	asm volatile ("movl %%cr0, %%eax" : "=a" (result) :); break;	
		case 1:	asm volatile ("movl %%cr1, %%eax" : "=a" (result) :); break;	
		case 2:	asm volatile ("movl %%cr2, %%eax" : "=a" (result) :); break;
		case 3:	asm volatile ("movl %%cr3, %%eax" : "=a" (result) :); break;
		case 4:	asm volatile ("movl %%cr4, %%eax" : "=a" (result) :); break;
		case 5:	asm volatile ("movl %%cr5, %%eax" : "=a" (result) :); break;
		case 6:	asm volatile ("movl %%cr6, %%eax" : "=a" (result) :); break;
		case 7:	asm volatile ("movl %%cr7, %%eax" : "=a" (result) :); break;
	};
	return result;
};

void WriteCr(uint32_t _value, uint8_t _cr)
{
	switch (_cr)
	{
		case 0:	asm volatile ("movl %%eax, %%cr0" : :"a" (_value) ); break;	
		case 1:	asm volatile ("movl %%eax, %%cr1" : :"a" (_value) ); break;
		case 2:	asm volatile ("movl %%eax, %%cr2" : :"a" (_value) ); break;
		case 3:	asm volatile ("movl %%eax, %%cr3" : :"a" (_value) ); break;
		case 4:	asm volatile ("movl %%eax, %%cr4" : :"a" (_value) ); break;
		case 5:	asm volatile ("movl %%eax, %%cr5" : :"a" (_value) ); break;
		case 6:	asm volatile ("movl %%eax, %%cr6" : :"a" (_value) ); break;
		case 7:	asm volatile ("movl %%eax, %%cr7" : :"a" (_value) ); break;
	};
};

uint8_t ReadCmos (uint8_t _register)
{
	outb(0x70, _register);
	return inb(0x71);
};

void halt(){
	asm ("hlt");
}

