/*
;
;---------------------------------------------------------------+
;       .__               __                          			
;______ |__|___________ _/  |_            ____  ______			
;\____ \|  \_  __ \__  \\   __\  ______  /  _ \/  ___/			
;|  |_> >  ||  | \// __ \|  |   /_____/ (  <_> )___ \ 			
;|   __/|__||__|  (____  /__|            \____/____  >			
;|__|                  \/                          \/ 			
;---------------------------------------------------------------+
;
;[1] Informations
;
; Last Modified: 	21. Mrz 2005
; Begin: 			21. Mrz 2005
; Version: 			0.000
; Coder: 			z4ck
;
;
;[2] Tasks
;
;	Task									Done		Coder
;----------------------------------------------------------------
; -                  						[  0%]		z4ck
;----------------------------------------------------------------
; TOTAL										[  0%]		z4ck
;================================================================
*/
#include <task/list.h>
#include <mm/mm.h>

List * NewList()
{
	List *tmpLst = malloc(sizeof(List));
	tmpLst->size = 0;
	tmpLst->first = NULL;
	tmpLst->last = NULL;
	
	return tmpLst;

}


void ListAdd(List *_root, void *_item)
{
	ListElement *tmpLstE = malloc(sizeof(ListElement));
	
	tmpLstE->item = _item;
	tmpLstE->prev = _root->last;
	tmpLstE->next = NULL;
	
	if (_root->first == NULL) _root->first 		= tmpLstE;
	if (_root->last  != NULL) _root->last->next	= tmpLstE;
	
	_root->last = tmpLstE;
	
	_root->size++;

}


void ListRemove(List *_root, void *_item)
{	
	if (_root->size == 0)
		return;
		
	ListElement *tmpListE = ListFind(_root, _item);
	
	if (tmpListE == NULL)
		return;
	
	if (_root->first == tmpListE)
		_root->first = tmpListE->next;
		
	if (_root->last  == tmpListE)
		_root->last  = tmpListE->prev;
		
	if (tmpListE->next != NULL)
		tmpListE->next->prev = tmpListE->prev;
	
	if (tmpListE->prev != NULL)
		tmpListE->prev->next = tmpListE->next;
		
	free(tmpListE);
	
	_root->size--;
	
}

ListElement * ListFind(List *_root, void *_item)
{
	ListElement *tmpListE = _root->first;
	
	while (tmpListE)
	{
		if (tmpListE->item == _item)
			break;	
		tmpListE = tmpListE->next;
	}
	
	return tmpListE;
}

void * ListGet(List *_root, uint32_t _number)
{
	uint32_t i = 0;
	
	ListElement *tmpListE = _root->first;
	
	while (tmpListE && i != _number)
	{
		tmpListE = tmpListE->next;
		i++;
	}
	
	return tmpListE->item;
	


}

void DeleteList(List *_root)
{
	ListElement *tmpListE = _root->first;
	ListElement *tmpListEDel = NULL;
	
	while (tmpListE)
	{
		tmpListEDel = tmpListE;
		tmpListE = tmpListE->next;
		free(tmpListEDel);
	}
	
	free(_root);
}

void ListMoveToFirst(List *_root, void *_item)
{
	if (_root->size == 0 || _root->size == 1)
		return;
		
	ListElement *tmpListE = ListFind(_root, _item);
	
	if (tmpListE == NULL)
		return;
	
	if (_root->first == tmpListE)
		return;
		
	if (_root->last  == tmpListE)
	{
		_root->last->prev->next = NULL;
		_root->last  = tmpListE->prev;
	}	
	else
	{
		tmpListE->next->prev = tmpListE->prev;
		tmpListE->prev->next = tmpListE->next;
	}
	
	tmpListE->prev = NULL;
	tmpListE->next = _root->first;
	_root->first = tmpListE;
}

void ListMoveToLast(List *_root, void *_item)
{
	if (_root->size == 0 || _root->size == 1)
		return;
		
	ListElement *tmpListE = ListFind(_root, _item);
	
	if (tmpListE == NULL)
		return;
	
	if (_root->last == tmpListE)
		return;
		
	if (_root->first  == tmpListE)
	{
		_root->first->next->prev = NULL;
		_root->first  = tmpListE->next;
	}	
	else
	{
		tmpListE->next->prev = tmpListE->prev;
		tmpListE->prev->next = tmpListE->next;
	}
	
	tmpListE->next = NULL;
	tmpListE->prev = _root->last;
	_root->last = tmpListE;
}
